/**
 *
 * @param v
 * @returns
 */
const required = (v) => {
    if (v === null)
        return "This field is required.";
    if (v === undefined)
        return "This field is required.";
    if (v === 0)
        return "This field is required.";
    if (v === "")
        return "This field is required.";
    if (Array.isArray(v) && v.length === 0)
        return "This field is required.";
    return true;
};
/**
 * Validate the value is alphanumeric
 * @param v
 * @returns
 */
const alphaNum = (v) => {
    return /^[a-z0-9]+$/i.test(v) || "The field is not alphanumeric.";
};
/**
 *
 * @param v
 * @param param1
 * @returns
 */
const between = (v, [min, max]) => {
    return (v > min && v < max) || `The field is not between ${min} and ${max}.`;
};
/**
 *
 * @param v
 * @returns
 */
const url = (v) => {
    return (/(https?:\/\/(?:www\.|(?!www))[a-zA-Z0-9][a-zA-Z0-9-]+[a-zA-Z0-9]\.[^\s]{2,}|www\.[a-zA-Z0-9][a-zA-Z0-9-]+[a-zA-Z0-9]\.[^\s]{2,}|https?:\/\/(?:www\.|(?!www))[a-zA-Z0-9]+\.[^\s]{2,}|www\.[a-zA-Z0-9]+\.[^\s]{2,})/.test(v) || "This field is not url.");
};
/**
 *
 * @param v
 * @returns
 */
const unique = (v) => {
    const map = new Map();
    for (let i = 0; v.length; i++) {
        if (map.has(v))
            return "This field is not unique.";
        map.set(v, true);
    }
    return true;
};
/**
 * Check both field are equals
 *
 * @param {any} v
 * @param param1
 * @param {FormControl} ctx
 * @returns {ValidationResult}
 */
const same = (v, [name], ctx) => {
    return v !== ctx.getValue(name)
        ? `The field must have the same vaue as ${name} `
        : true;
};
/**
 *
 * @param v
 * @returns
 */
const email = (v) => /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(v) || "This field must be a valid email.";
/**
 *
 * @param v
 * @param list
 * @returns
 */
const contains = (v, list) => {
    return (list.includes(v) || `This field doesn't have valid value (such as ${list.join(", ")})`);
};
/**
 *
 * @param val
 * @param param1
 * @returns
 */
const minLength = (val, [min]) => {
    if (Array.isArray(val) && val.length < min) {
        return `Array must contains ${min} items.`;
    }
    const typeOfVal = typeof val;
    switch (typeOfVal) {
        case "string":
            return (val.length >= Number(min) || `This field must be at least ${min} characters.`);
    }
    return "invalid data type for minLength";
};
/**
 *
 * @param v
 * @param param1
 * @returns
 */
const max = (v, [len]) => {
    const l = parseFloat(len);
    const value = isNaN(v) ? v.length : parseFloat(v);
    return value < l || `This field must be less than ${length} characters.`;
};
/**
 *
 * @param v
 * @param param1
 * @returns
 */
const min = (v, [len]) => {
    const l = parseFloat(len);
    const value = isNaN(v) ? v.length : parseFloat(v);
    return value >= l || `This field must be at least ${l} characters.`;
};
/**
 *
 * @param v
 * @returns
 */
const integer = (v) => {
    return /^\d+$/.test(v) || "The field is not an integer";
};

export { alphaNum, between, contains, email, integer, max, min, minLength, required, same, unique, url };
